Index: src/account-setup-eplugin/exchange-mapi-account-listener.c
===================================================================
--- src/account-setup-eplugin/exchange-mapi-account-listener.c.orig
+++ src/account-setup-eplugin/exchange-mapi-account-listener.c
@@ -28,7 +28,7 @@
 #include "exchange-mapi-account-listener.h"
 #include "exchange-mapi-account-setup.h"
 #include <string.h>
-#include <camel/camel-i18n.h>
+#include <glib/gi18n-lib.h>
 #include <libedataserverui/e-passwords.h>
 #include "e-util/e-error.h"
 #include <libedataserver/e-account.h>
Index: src/account-setup-eplugin/exchange-mapi-account-settings.c
===================================================================
--- src/account-setup-eplugin/exchange-mapi-account-settings.c.orig
+++ src/account-setup-eplugin/exchange-mapi-account-settings.c
@@ -25,7 +25,7 @@
 #include <config.h>
 #endif
 
-#include <glib/gi18n.h>
+#include <glib/gi18n-lib.h>
 #include <gtk/gtk.h>
 
 #include <camel/camel-provider.h>
Index: src/account-setup-eplugin/exchange-mapi-account-setup.c
===================================================================
--- src/account-setup-eplugin/exchange-mapi-account-setup.c.orig
+++ src/account-setup-eplugin/exchange-mapi-account-setup.c
@@ -28,7 +28,7 @@
 
 #include <string.h>
 #include <unistd.h>
-#include <glib/gi18n.h>
+#include <glib/gi18n-lib.h>
 
 #include <gtk/gtk.h>
 #include <camel/camel-provider.h>
Index: src/addressbook/e-book-backend-mapi-gal.c
===================================================================
--- src/addressbook/e-book-backend-mapi-gal.c.orig
+++ src/addressbook/e-book-backend-mapi-gal.c
@@ -7,6 +7,7 @@
 #include <string.h>
 #include <glib.h>
 #include <glib/gstdio.h>
+#include <glib/gi18n-lib.h>
 
 #include <sys/time.h>
 
Index: src/calendar/e-cal-backend-mapi.c
===================================================================
--- src/calendar/e-cal-backend-mapi.c.orig
+++ src/calendar/e-cal-backend-mapi.c
@@ -25,7 +25,7 @@
 #include <config.h>
 #endif
 
-#include <glib/gi18n.h>
+#include <glib/gi18n-lib.h>
 #include <gio/gio.h>
 
 #include "e-cal-backend-mapi.h"
Index: src/camel/camel-mapi-provider.c
===================================================================
--- src/camel/camel-mapi-provider.c.orig
+++ src/camel/camel-mapi-provider.c
@@ -34,7 +34,7 @@
 #include <camel/camel-session.h>
 #include <camel/camel-url.h>
 #include <camel/camel-sasl.h>
-#include <camel/camel-i18n.h>
+#include <glib/gi18n-lib.h>
 
 #include "camel-mapi-store.h"
 #include "camel-mapi-transport.h"
@@ -110,6 +110,7 @@ void
 camel_provider_module_init(void)
 {
 	mapi_provider.name = "Exchange MAPI";
+	mapi_provider.translation_domain = (gchar *) GETTEXT_PACKAGE;
 	mapi_provider.auto_detect = mapi_auto_detect_cb;
 	mapi_provider.authtypes = g_list_prepend (mapi_provider.authtypes, &camel_mapi_password_authtype);
 	mapi_provider.url_hash = mapi_url_hash;
@@ -117,6 +118,10 @@ camel_provider_module_init(void)
 	mapi_provider.license = "LGPL";
 	mapi_provider.object_types[CAMEL_PROVIDER_STORE] = camel_mapi_store_get_type();
 	mapi_provider.object_types[CAMEL_PROVIDER_TRANSPORT] = camel_mapi_transport_get_type();
+
+	bindtextdomain (GETTEXT_PACKAGE, EXCHANGE_MAPI_LOCALEDIR);
+	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
+
 	camel_provider_register (&mapi_provider);
 }
 
Index: src/camel/camel-mapi-store.c
===================================================================
--- src/camel/camel-mapi-store.c.orig
+++ src/camel/camel-mapi-store.c
@@ -44,7 +44,7 @@
 #include <camel/camel-session.h>
 #include <camel/camel-service.h>
 #include <camel/camel-store-summary.h>
-#include <camel/camel-i18n.h>
+#include <glib/gi18n-lib.h>
 #include <camel/camel-net-utils.h>
 
 #include "camel-mapi-store.h"
Index: src/camel/camel-mapi-store.h
===================================================================
--- src/camel/camel-mapi-store.h.orig
+++ src/camel/camel-mapi-store.h
@@ -28,7 +28,7 @@
 #include <camel/camel-offline-store.h>
 #include <camel-mapi-store-summary.h>
 #include <camel/camel-net-utils.h>
-#include <camel/camel-i18n.h>
+#include <glib/gi18n-lib.h>
 
 #include <exchange-mapi-folder.h>
 
Index: src/camel/camel-mapi-transport.c
===================================================================
--- src/camel/camel-mapi-transport.c.orig
+++ src/camel/camel-mapi-transport.c
@@ -57,7 +57,7 @@
 
 
 #include <camel/camel-private.h>
-#include <camel/camel-i18n.h>
+#include <glib/gi18n-lib.h>
 #include <camel/camel-net-utils.h>
 #include "camel-mapi-store.h"
 #include "camel-mapi-folder.h"
Index: src/camel/camel-mapi-utils.c
===================================================================
--- src/camel/camel-mapi-utils.c.orig
+++ src/camel/camel-mapi-utils.c
@@ -41,7 +41,7 @@
 #include <camel/camel-stream-mem.h>
 
 #include <camel/camel-private.h>
-#include <camel/camel-i18n.h>
+#include <glib/gi18n-lib.h>
 #include <camel/camel-net-utils.h>
 #include <camel/camel-seekable-stream.h>
 #include <camel/camel-sasl.h>
Index: src/camel/Makefile.am
===================================================================
--- src/camel/Makefile.am.orig
+++ src/camel/Makefile.am
@@ -10,6 +10,7 @@ AM_CPPFLAGS = -I.. 				\
 	$(CAMEL_CFLAGS)				\
 	$(LIBECAL_CFLAGS)			\
         $(LIBMAPI_CFLAGS)                       \
+	-DEXCHANGE_MAPI_LOCALEDIR=\"$(localedir)\" \
 	-DG_LOG_DOMAIN=\"camel-mapi-provider\"
 
 libcamelmapi_la_SOURCES = 			\